using Bp.Sync.BackEnd.Infrastructure.Repositories.FcCustomers;
using Bp.Sync.Domain.Entities.FcBusinesses;
using Bp.Sync.Domain.Entities.FcCustomers.Customers;
using Bp.Sync.Dto.Results;
using CommonLibrary;
using Dapper;
using EasyNetQ;
using Microsoft.Extensions.Configuration;
using System;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Vina.Search.Infrastructure.Mappings;

namespace Bp.Sync.BackEnd.Application.Commands.FcCustomers
{
    public class SyncFcCustomerHandler : MediatR.IRequestHandler<SyncFcCustomerCommand, BaseResult>
    {
        private readonly IDbConnection _dbConnection;
        private readonly IFcCustomerRepository _FcCustomerRepository;
        private readonly IBus _bus;

        public SyncFcCustomerHandler(IConfiguration configuration, IFcCustomerRepository FcCustomerRepository, IBus bus)
        {
            var connectionString = configuration.GetConnectionString("FcCustomerConnection");
            _dbConnection = new SqlConnection(connectionString);
            _FcCustomerRepository = FcCustomerRepository;
            _bus = bus;
        }

        public async Task<BaseResult> Handle(SyncFcCustomerCommand request, CancellationToken cancellationToken)
        {
            var rs = new BaseResult();

            if (request.Ids.Count() > 1000)
            {
                var length = request.Ids.Count();
                if (length > 0)
                {
                    for (int i = 0; i <= length / 1000; i++)
                    {
                        if (length > i * 1000)
                        {
                            var ids = request.Ids.Skip(i * 1000).Take(1000).ToList();
                            if (ids.Count() > 0)
                            {
                                await _bus.SendAsync($"SyncToElasticFcCustomer", ids.ConvertListLongToString());
                            }
                        }
                    }
                }
                return new BaseResult { Result = Result.Success, Message = $"sent {length} FcCustomers" };
            }
            if (!request.Ids.Any())
            {
                rs.Message = $"no data to update";
                rs.Result = Dto.Results.Result.Success;
                return rs;
            }

            try
            {
                var p = new Dto.DapperTypes.IdsParam(request.Ids);
                var FcCustomers = await _dbConnection.QueryAsync<FcCustomer>("Sync_FcCustomer_Get_By_List_Id", p, commandType: CommandType.StoredProcedure);
                if (FcCustomers.Any())
                {
                    var FcCustomerRs = FcCustomers.ToFcCustomers();
                    var rs2 = await _FcCustomerRepository.AddManyAsync(FcCustomerRs);
                    if (rs2.Result == Result.Success)
                    {
                        await _dbConnection.ExecuteAsync("Synced_FcCustomer_By_List_Id", p, commandType: CommandType.StoredProcedure);
                        rs.Message = $"{FcCustomerRs.Count()} synced";
                        rs.Result = Result.Success;
                    }
                    else
                    {
                        rs.Message = $"can not insert db";
                        rs.Result = Result.Success;
                    }
                }
                else
                {
                    rs.Message = $"no data to update";
                    rs.Result = Result.Success;
                }
            }
            catch (Exception ex)
            {
                rs.Message = ex.Message.ToString();
                rs.Result = Result.SystemError;
            }
            return rs;
        }
    }
}